{ 
/* GetZTenv.AHK -- Include file for any script for ZTree enhancing

Author:     Slobodan Vujnovic 
Purpose:    Get info about ZTree
Notes:

Requirements:

History: 
    20070215 SV Creation
    20120324 SV Prefix all functions with GetZTxxx
 
Functions:
    GetZTbar()        ; Get current object and ZTree mode: DW, FW, F9, View
    GetZTpath(pid)    ; Get current object and ZTree mode: DW, FW, F9, View
    GetZTcontext()    ; Get current object and ZTree mode: DW, FW, F9, View
    GetZTenv()        ; Get ZTree environment info: ZThome, etc.

TODO: Get interesting #ZTvars
#ZTArgs=/ZM /ZD /Y /TZ /TV /ZIZTW_Slo.INI /ZCZCOLORS_Blue.INI /ROWS:83:66:25 /COLS:210:160:120:80  /Y /T"  [Blue] Windows_NT  vujnovic on MALI\MALI (\\MALI)"  /TO
#ZTDesktop=C:\Documents and Settings\vujnovic\Desktop
#ZTDrive=C
#ZTExe=ZTW.EXE
#ZTFavorites=C:\Documents and Settings\vujnovic\Favorites
#ZTHome=C:\ZTW
#ZTIniPath=C:\ZTW\ZTW_Slo.INI
#ZTMyDocuments=C:\Documents and Settings\vujnovic\My Documents
#ZTStartMenu=C:\Documents and Settings\vujnovic\Start Menu
#ZTTemp=C:\Temp\ZTMP000
#ZTTools=\1
#ZTZColorsPath=C:\ZTW\ZCOLORS_Blue.INI

TODO: 
TODO: 

*/ }

GetZTenv()        ; Get ZTree environment info: #ZThome, etc.
{
/* 
; Parse output from: SET #ZT > %TEMP%\ezff.tmp
; Obviously, this works only if ZTree is the active app!
; TODO: We must skip it otherwise!
; TODO: 
; NOTE: Currently, there are 12 EVs, but the list and order
;       may change! For example, #ZTExe=ZTW.EXE was added 
;       sometime in 2012.
  1 #ZTArgs=/ZM /ZD /Y /TZ /TV /ZIZTW_Slo.INI /ZCZCOLORS_Blue.INI /ROWS:83:6...
  2 #ZTDesktop=C:\Documents and Settings\vujnovic\Desktop
  3 #ZTDrive=C
  4 #ZTExe=ZTW.EXE
  5 #ZTFavorites=C:\Documents and Settings\vujnovic\Favorites
> 6 #ZTHome=C:\ZTW
> 7 #ZTIniPath=C:\ZTW\ZTW_Slo.INI
  8 #ZTMenu=C:\ZTW\slo.ZAM
  9 #ZTMyDocuments=C:\Documents and Settings\vujnovic\My Documents
 10 #ZTStartMenu=C:\Documents and Settings\vujnovic\Start Menu
>11 #ZTTemp=C:\Temp\ZTMP000
 12 #ZTTools=\1
 13 #ZTZColorsPath=C:\ZTW\ZCOLORS_Blue.INI

-------------------------------------------------------------------------------
 
*/

global ZThome, ZTtemp, ZTini
SendInput {Esc}{Esc}{Esc}xSET {#}ZT>%TEMP%\ezff.tmp{Enter}{Esc}
Sleep, 1000  ; 1 second
FileReadLine, line, %TEMP%\ezff.tmp, 6  ;FileRead, Contents, %TEMP%\ezff.tmp
    StringSplit,array,line,=     ; StringSplit, OutputArray, InputVar [, Delimiters, OmitChars]
    ZThome := array2    ; Save in global
; MsgBox, 0, ZThome, %line% `n`n%array2%`n
FileReadLine, line, %TEMP%\ezff.tmp, 7  ;FileRead, Contents, %TEMP%\ezff.tmp
    StringSplit,array,line,=     ; StringSplit, OutputArray, InputVar [, Delimiters, OmitChars]
    ZTini := array2    ; Save in global
; MsgBox, 0, ZTini, %line% `n`n%array2%`n
FileReadLine, line, %TEMP%\ezff.tmp, 11  ;FileRead, Contents, %TEMP%\ezff.tmp
    StringSplit,array,line,=     ; StringSplit, OutputArray, InputVar [, Delimiters, OmitChars]
    ZTtemp := array2    ; Save in global
; MsgBox, 0, ZTtemp, %line% `n`n%array2%`n
    line =              ; Free memory
    array =             ; Free memory
IfExist, %TEMP%\ezff.tmp
    FileDelete, %TEMP%\ezff.tmp
return
}

GetZTcontext()          ; Get current object and ZTree mode: DW, FW, F9, View
{
global ZTmode, ZTobject, ZTversion, ZTproc, ZTprocID, ZTexe
WinActivate             ; Activate the window found above
WinGetActiveTitle, Title 
/*
ZTreeWin v1.60.rc35 [User Title] - "dir\" or "file" or "C:\dir\file"
StringSplit, junk, Title,-
MsgBox, 4,,[junk0:%junk0%]
MsgBox, 4,,[junk1:%junk1%]
MsgBox, 4,,[junk2:%junk2%]
*/
; ZTobject := SubStr(junk2, 2)    ; Get rid of leading space
ZTprocID    := "?"
ZTversion   := "?"
ZTobject    := "?"
ZTmode      := "?"
; WinGet, OutputVar [, Cmd, WinTitle, WinText, ExcludeTitle, ExcludeText]
WinGet, ZTproc, ProcessName
WinGet, ZTprocID, PID
ZTexe := GetZTpath(ZTprocID)  ; Get current object and ZTree mode: DW, FW, F9, View
FileGetVersion, ZTversion, %ZTexe%
GetZTbar()   ; Get lots of info from zbar.dat
/* If zbar.dat is not available, we can try parsing the title...
;StringGetPos, StartPos, Title,%A_Space%-%A_Space%
StringGetPos, StartPos, Title, ZTreeWin
;ZTversion := SubStr(Title, StartPos+10)   ; Get version
StringGetPos, StartPos, Title,-
if ErrorLevel
    return
;StringGetPos, OutputVar, InputVar, SearchText [, L#|R#, Offset]
;if StartPos >= 0
;    MsgBox, The string was found at position %StartPos%.
;ZTobject := SubStr(Title, StartPos+3) 
Drive := SubStr(ZTobject, 2, 1)  ; See if we have "C:\dir\file"
;MsgBox, 4,,[ZTobject:%ZTobject%]
;MsgBox, 4,,[Drive:%Drive%]
ZTmode := SubStr(Title, 0, 1)   ; Get last char
If ZTmode = \   ; Is it a '\' ?
    ZTmode := "DW"
else
    ZTmode := "FW"
If Drive = :
    ZTmode := "F9,FW"
Title =             ; Free memory
Drive =             ; Free memory
junk =              ; Free memory
*/
return
}

GetZTpath(pid)      ; Get current object and ZTree mode: DW, FW, F9, View
{
; Open process with: PROCESS_VM_READ (0x0010) | PROCESS_QUERY_INFORMATION (0x0400):
hProcess := DllCall("OpenProcess", "UInt", 0x0010 | 0x0400, "Int", false, "UInt", pid)
size := VarSetCapacity(filename, 250) ; max. length of filename
DllCall("Psapi.dll\GetModuleFileNameExA", "UInt", hProcess, "Int", 0, "Str", filename, "Int", size)
DllCall("CloseHandle", "UInt", hProcess)
return %filename%
}

GetZTbar()        ; Get current object and ZTree mode: DW, FW, F9, View
{
global ZTmode, ZTobject, ZThome, ZTbyte11, ZTbyte8

/*
If the specified file contains any binary zeros (which never occur in 
proper text files), only the text before the first binary zero will 
be "seen" by AutoHotkey commands and functions. However, the entire 
contents are still present in OutputVar and can be accessed by 
advanced methods such as the address operator (&); for example: *(&OutputVar + 1000)

FileRead can be used to quickly sort the contents of a file as in the following example:
ZTreeWin screen status informs the AAs what type of screen
 is being used in Z so they can adjust their owns.
   n - Normal screen is in use.
   l - Left pane is active in split-view.
   r - Right pane is active in split-view.
   7 - Auto-view is in use.
   v - Internal Viewer is in use (in standard mode)
   x - Execute screen is in use.
   m - Menu screen is in use.
   s - Statistics screen is in use.

SetBatchLines -1

File := A_WinDir . "\System32\himem.sys" ; Choose your file
FileGetSize, dataSz  , %File%
FileRead   , binData , %File%
Pointer := &binData
MsgBox, % Mem2Hex( Pointer, dataSz )
Return

Mem2Hex( pointer, dataSz ) {
 A_FI := A_FormatInteger
 SetFormat, Integer, Hex
 Loop, %dataSz%  {
                   Hex := *Pointer+0
                   StringReplace, Hex, Hex, 0x, 0x0
                   StringRight Hex, Hex, 2           
                   hexDump := hexDump . hex
                   Pointer ++
                 }
 SetFormat, Integer, %A_FI%
 StringUpper, hexDump, hexDump
Return hexDump
                          }
*/

FileRead, zbar, %ZThome%\zbar.dat
ZTobject := "#ZThome\zbar.dat not found!"
ZTbyte8  := "?"
ZTbyte11 := "?"
if not ErrorLevel  ; Successfully loaded.
{
    ZTbyte8  := CHR(*(&zbar + 7))   ; Get byte and make it a char
    ZTbyte11 := CHR(*(&zbar + 10))  ; Get byte and make it char (D or F)
    ;MsgBox, 4,,%ZTByte8%
    ptr := (&zbar + 11)
    ZTobject := ""
    Loop    {
            if (*ptr) = 0   ; Get byte and make it a char
                break
            chr := CHR(*ptr)   ; Get byte and make it a char
            ;MsgBox, 4,,%chr%
            ZTobject := ZTobject . chr
            ptr ++
            }
    ptr  =  ; Free the memory.
    chr  =  ; Free the memory.
    zbar =  ; Free the memory.
}
return
}
